/*$Id: Choice.java,v 1.2 2004/09/24 14:30:30 uid523 Exp $*/
package jsim;
import java.awt.*;
import java.awt.event.*;
import java.io.*;
import java.util.*;
import javax.swing.*;
import javax.swing.event.*;
import javax.swing.border.*;
import javax.swing.table.*;


 
class Choice extends Box  {
     class MyListSelectionListener implements ListSelectionListener {
       public void valueChanged(ListSelectionEvent e) {
          if (e.getValueIsAdjusting() || e.getFirstIndex()==-1) return;
          JList src = (JList) e.getSource();
          Object[] s = src.getSelectedValues();
          for (int i=0;i<s.length;i++) {
            if (s!=null && s[i] instanceof SummandButton)
            Main.request.sendMsg(new MarkMsg(((SummandButton) s[i]).pos));
            }
          } 
        MyListSelectionListener() {super();} 
        }
        
     abstract class ExtendAction extends AbstractAction {
          public ExtendAction(String text, String desc) {
              super(text);
              putValue(SHORT_DESCRIPTION, desc);
          }
          }
             
    class MyListCellRenderer extends DefaultListCellRenderer implements 
       ListCellRenderer {
         Hashtable colors = new Hashtable();
         public MyListCellRenderer() {
             super();
             colors.put("red", Color.red);
             colors.put("blue", Color.blue);
             colors.put("gray", Color.gray);
             colors.put("black", Color.black);
             colors.put("lightGray", Color.lightGray);
             colors.put("darkGray", Color.darkGray);
             colors.put("pink", Color.pink);
             colors.put("magenta", Color.magenta);
             colors.put("green", Color.green);
             }
         public Component getListCellRendererComponent(
             JList list,
             Object value,
             int index,
             boolean isSelected,
             boolean cellHasFocus)
         {
             if (value instanceof ListButton) {
             // System.err.println("renderer:"+value+":"+((ListButton) value).name+
             // ((ListButton) value).leaf+":"+((ListButton) value).color);
               super.getListCellRendererComponent(list,
               ((ListButton) value).name, index, 
               ((ListButton) value).name.equals("#deadlock#")?false:isSelected, 
               cellHasFocus).
               setForeground(
                 (Color) colors.get(((ListButton) value).color));
               }
             return this;
         }
         }
         
       class OtherCellRenderer extends DefaultListCellRenderer implements 
       ListCellRenderer {
         public OtherCellRenderer() {
             super();
             }
         public Component getListCellRendererComponent(
             JList list,
             Object value,
             int index,
             boolean isSelected,
             boolean cellHasFocus)
         {
         if (value instanceof SummandButton) {
               super.getListCellRendererComponent(list,
               ((SummandButton) value).smd, index, 
               Boolean.valueOf(((SummandButton) value).marked).booleanValue()?
               true:isSelected,  cellHasFocus);
               }
         return this;
         }
     }
     final MyListSelectionListener 
          listSelectionListener = new MyListSelectionListener();
     final JList actions = new JList(), smds;
     final JLabel depthSmd = new JLabel() {
           public Dimension getPreferredSize()  {
           return new Dimension(68, depthAction.getPreferredSize().height);}
           public void setText(String aap) {
                 super.setText(aap.equals("0")?" ":aap);
                 }
           };
     final JButton depthAction = 
      new JButton(new ExtendAction("init",
          "Click here to explore the current state") {
      public void actionPerformed(ActionEvent e) {
          Main.frame.setAll(false);
          Main.request.sendMsg(new SteprankMsg(((JButton) e.getSource()).
          getActionCommand()));
          }
      });
     final String deadlock="#deadlock#";
         
     Choice (String name) {        
       super(BoxLayout.Y_AXIS);
       depthAction.setEnabled(false);
       depthSmd.setBorder(BorderFactory.createEtchedBorder());
       JScrollPane depth = new JScrollPane(depthAction);
       ((JComponent) this.add(depth)).setPreferredSize(
             new Dimension(Main.width/2,60));
       depth.setMaximumSize(new Dimension(10000,depth.getPreferredSize().height));
       depth.setMinimumSize(depth.getPreferredSize());
       depth.setRowHeaderView(depthSmd);
       depth.setColumnHeaderView(new JLabel("Last Action",JLabel.CENTER));
       depth.setCorner(JScrollPane.UPPER_LEFT_CORNER, new JLabel("smd."));
       JScrollPane scrollpane =  new JScrollPane();
       smds = new JList() {public Dimension getPreferredSize()  {
           return new Dimension(70, actions.getPreferredSize().height);
           }};
       smds.setCellRenderer(new OtherCellRenderer());
       smds.setFixedCellWidth(70);
       smds.setBorder(BorderFactory.createEtchedBorder());
       smds.setFocusable(false);
       smds.addListSelectionListener(listSelectionListener); 
       smds.setToolTipText("Click here to mark a transition");
       // smds.setSelectionMode(ListSelectionModel.MULTIPLE_SELECTION);
       
       actions.setCellRenderer(new MyListCellRenderer());
       actions.setBorder(BorderFactory.createEtchedBorder());
       actions.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
       actions.setFocusable(false);
       // actions.setFixedCellWidth(Main.width/2-70);
       scrollpane.setViewportView(actions);
       scrollpane.setColumnHeaderView(new JLabel(name,JLabel.CENTER));
       scrollpane.setCorner(JScrollPane.UPPER_LEFT_CORNER, new JLabel("smd."));
       scrollpane.setRowHeaderView(smds);
       // scrollpane.setPreferredSize(
       //    new Dimension(Main.width/2-70, scrollpane.getPreferredSize().height));
       this.add(scrollpane);
       
     }
}

class MyModel extends AbstractListModel implements ListDataListener {
    private Vector v = new Vector();
    public void contentsChanged(ListDataEvent e) {
       Main.frame.choice.actions.setEnabled(true);   
       }   
    public void intervalAdded(ListDataEvent e) {}
    public void intervalRemoved(ListDataEvent e) {}
     
    public void setLocal(Vector a) {
	v = (Vector) (a.clone()); 
        fireContentsChanged(Main.frame.choice, 0, 0);
        }
	
    public Object getElementAt(int index) {return v.get(index);}
    public int getSize() {return v.size();}
    MyModel () {
       addListDataListener(this);
       }
    }
    
class ChoiceBuild extends Choice implements ListSelectionListener {
        
    public void valueChanged(ListSelectionEvent e) {
      if (
      ((JList) e.getSource()).getSelectedValue()==null ||
      e.getValueIsAdjusting() || e.getFirstIndex()<0) return;
//System.out.println("Selected value "+((JList)e.getSource()).getSelectedValue());
          JList src = (JList) e.getSource();
      Object s = src.getSelectedValue();
      if (s==null) return; 
      String pos =  ((s instanceof ListButton)? ((ListButton) s).pos: 
            (String) s);
      src.clearSelection();
      Main.frame.setAll(false);
      if (s instanceof ListButton) {
        Main.request.sendMsg((Msg) new RedoMsg(pos));
         }
      }
      
      ChoiceBuild() {
       super("Choose action");
       actions.addListSelectionListener(this);
       actions.setModel(new MyModel());
      } 
   }
   
class Table extends JScrollPane  {
   private DefaultTableCellRenderer renderer0 = 
             new DefaultTableCellRenderer();
   private DefaultTableCellRenderer renderer1 = 
             new DefaultTableCellRenderer(); 
   private Vector data = new Vector(0);
       
   void initColumnSizes() {
        TableModel tableModel = table.getModel();
        int nrows = table.getRowCount();
        int cellWidth = 120;
        for (int i=0;i<nrows;i++) {
           Object s = tableModel.getValueAt(i,3);
           Component comp = table.getDefaultRenderer(tableModel.getColumnClass(3)).
           getTableCellRendererComponent(table, s ,false, false, i, 3);
           cellWidth = Math.max(cellWidth, comp.getPreferredSize().width);
           }
      table.getColumnModel().getColumn(3).setPreferredWidth(cellWidth+15);
      }
    
   void setData(Vector data) {this.data = data;}  
           
   class TableColumnModel extends DefaultTableColumnModel {
      class MyTableColumn extends TableColumn {
         MyTableColumn(int i, int width, String name, TableCellRenderer renderer) {
            super(i, width);
            setCellRenderer(renderer);
            setHeaderRenderer(createDefaultHeaderRenderer());
            setHeaderValue(name);
            }       
         }
      
       TableColumnModel() {
         addColumn(new MyTableColumn(0, 50,"level", renderer0));
         addColumn(new MyTableColumn(1, 50,"depth", renderer0));
         addColumn(new MyTableColumn(2, 60, "smd", renderer0));
         addColumn(new MyTableColumn(3, 480, "action", renderer0));
         }
      }
   
   class MyTableModel extends AbstractTableModel { 
      MyTableModel() {
          super();
          }
      public int getRowCount() {return data.size()/5;}
      public int getColumnCount() {return 4;}
      public Object getValueAt(int r, int c) {return data.get(r*5+c%4);}
      public String getCurrent(int r) {return (String)(data.get(r*5+4));}
      }
        
   private MyTableModel dm  =new MyTableModel();
        
   private TableColumnModel dcm = new TableColumnModel();
   
   final JTable  table = new JTable(dm, dcm); 
   
   Table() {
        table.setAutoResizeMode(JTable.AUTO_RESIZE_OFF);
        table.setCellSelectionEnabled(false);
        table.setColumnSelectionAllowed(false);
        table.setRowSelectionAllowed(true);
        table.setFocusable(false);
        table.getSelectionModel().
              setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
        table.getSelectionModel().addListSelectionListener(new 
          ListSelectionListener() {
             public void valueChanged(ListSelectionEvent e) {
             if (e.getValueIsAdjusting() || e.getFirstIndex()==-1) return;
             int r = table.getSelectedRow();
             if (r== -1) return;
             Main.request.sendMsg(new RedoMsg( 
               ((MyTableModel) (table.getModel())).getCurrent(r)));
             ((ListSelectionModel) (e.getSource())).clearSelection();
             } 
         });
        table.setToolTipText(
        "Select a transition to make its source state current");
        setViewportView(table);
        setPreferredSize(
           new Dimension(Main.width/2-10, getPreferredSize().height));
        setMinimumSize(new Dimension(getPreferredSize().width,0));
        setMaximumSize(new Dimension(getPreferredSize().width,10000));
        }    
   }
  
 class Mark extends Box {
   Table content = new Table();
   Mark() {
      super(BoxLayout.Y_AXIS);
      Box box = new Box(BoxLayout.X_AXIS);
      box.createHorizontalGlue();
      JLabel label = new JLabel("Marked transitions",JLabel.CENTER);
      box.add(label);
      box.createHorizontalGlue();
      // label.setMinimumSize(
      // new Dimension(Main.width/2, 20));
      // label.setMaximumSize(new Dimension(10000, 20));
      // box.setBorder(BorderFactory.createEtchedBorder(EtchedBorder.RAISED));
      this.add(box);
      this.add(content);
      }    
   }
