/*$Id: MyFileChooser.java,v 1.3 2004/07/14 15:19:01 bertl Exp $*/
package jsim;

import javax.swing.*;
import javax.swing.filechooser.*;
import java.io.File;
import java.util.Hashtable;

class MyFileChooser extends JFileChooser {
      Hashtable suffixToFilter = new Hashtable();
      class MyFileFilter extends FileFilter {
            private String ext, descr;
            MyFileFilter(String ext, String descr) {
               this.ext = ext;
               this.descr = descr;
               }
            public boolean accept(File f) {
               String s = f.getName();
               int n = s.lastIndexOf('.');
               String suffix = n>=0?s.substring(n):s;
               // System.out.println("QQQ:"+s+":"+ext);
               if (f.isDirectory() && 
                  suffixToFilter.get((Object) suffix) ==null) return true; 
               return s.endsWith(ext);
               }
            public String getDescription() {return descr;}
            }
            
       class DirFileFilter extends FileFilter {
            private String ext, descr;
            DirFileFilter(String ext, String descr) {
               this.ext = ext;
               this.descr = descr;
               suffixToFilter.put((Object) ext,this);
               }
               
            public boolean accept(File f) {
               String s = f.getName();
               int n = s.lastIndexOf('.');
               String suffix = n>=0?s.substring(n):s;
               if (f.isDirectory()) {
                 if (suffixToFilter.get((Object) suffix)==null 
                  || suffix.equals(ext)) return true;
               }
               return false;
             }
               
            public String getDescription() {return descr;}
            }   
       MyFileFilter bcgFilter = Boolean.valueOf(
            System.getProperty("bcg", "false")).booleanValue()?
          new MyFileFilter(".bcg", "\".bcg\" labeled transition systems"): 
          null,
          svcFilter = Boolean.valueOf(
            System.getProperty("svc", "false")).booleanValue()?
          new MyFileFilter(".svc", "\".svc\" labeled transition systems"): 
          null,
          autFilter =  
          new MyFileFilter(".aut", "\".aut\" labeled transition systems"), 
          tbfFilter = new MyFileFilter(".tbf", "\".tbf\" linear process operators");
       DirFileFilter 
            trcFilter = new DirFileFilter(".trc", "\".trc\" traces"),
            dirFilter = new DirFileFilter(".dir", "\".dir\" labeled transition systems"),
            dmpFilter = new DirFileFilter(".dmp", "\".dmp\" labeled transition systems");
       File oldFile = null;
       boolean isAutFile() {return getFileFilter().equals(autFilter) ||
       getFileFilter().equals(bcgFilter) || getFileFilter().equals(svcFilter)
           || getFileFilter().equals(dmpFilter) 
           || getFileFilter().equals(dirFilter);
           }
       MyFileChooser(File file) {
           super(file==null?
              System.getProperty("dir",System.getProperty("user.dir")):
              file.getAbsolutePath());
           setMultiSelectionEnabled(false);
           addChoosableFileFilter(tbfFilter);
           addChoosableFileFilter(autFilter);
           addChoosableFileFilter(trcFilter);
           if (svcFilter!=null)
           addChoosableFileFilter(svcFilter);
           if (bcgFilter!=null)
           addChoosableFileFilter(bcgFilter);
           addChoosableFileFilter(dmpFilter);
           addChoosableFileFilter(dirFilter);
           removeChoosableFileFilter(getAcceptAllFileFilter());
           setFileSelectionMode(JFileChooser.FILES_AND_DIRECTORIES);
           setFileFilter(tbfFilter);
           }
       }
   
