/* $Id: $ */
package jsim;
import java.awt.*;
import java.awt.event.*;
import java.io.*;
import java.util.*;
import javax.swing.event.*;
import javax.swing.*;
import javax.swing.text.*;
import javax.swing.table.*;
import java.text.SimpleDateFormat;
import java.text.ParseException;
import java.sql.Time;
import javax.swing.border.*;
import javax.swing.DefaultCellEditor;

/**
The scrollable panel which contains a table. 
*/
class StateTable extends JScrollPane {
   private AbstractTableModel dm;
   private DefaultTableColumnModel dcm;
   private Vector data = null;
   final private JTextField edt;
   /**  The table which will be displayed. */
   public JTable table;
   private final Color headerBackground;
   /** The renderer of the 0th column. */
   private final DefaultTableCellRenderer renderer0, renderer1;
   /** The column model belonging to the table. */
  private Vector w;
  
  private int m = 1;
   
  class Renderer0 extends DefaultTableCellRenderer {
    public Component getTableCellRendererComponent(JTable table,
       Object value, boolean isSelected, boolean hasFocus, int row,
       int column) { 
          Component c = row>=m?renderer0.getTableCellRendererComponent(table, value, 
           isSelected, hasFocus, row, column):
           renderer1.getTableCellRendererComponent(table, value, 
           isSelected, row+column==0, row, column);
       // if (row>=m) c.setBackground(headerBackground);
       c.setForeground(Color.black);
       return c;
       } 
   }
   
   class Renderer1 extends DefaultTableCellRenderer {
    public Component getTableCellRendererComponent(JTable table,
       Object value, boolean isSelected, boolean hasFocus, int row,
       int column) { 
          Component c = renderer1.getTableCellRendererComponent(table, value, 
           isSelected, row+column==0, row, column);
        // if (row==0) System.err.println(c.requestFocusInWindow());
        if (w!=null && column==2) {
           int ofs = table.getRowCount() - w.size();
          //if (w!=null) System.err.println(w.get(row)+" "+value);
           if (row>=ofs && !((String) value).equals((String)(w.get(row-ofs))))
               c.setForeground(Color.red);
          else c.setForeground(Color.black);
          }
       else c.setForeground(Color.black);
       return c;
       } 
   }
   
   private void initColumnSize2() {
        TableColumn column = null;
        Component comp = null;
        TableModel tableModel = table.getModel();
        int ncols = table.getColumnCount();
        int nrows = table.getRowCount();
        int cellWidth = 0;
        int d = table.convertColumnIndexToModel(2);
        column = table.getColumnModel().getColumn(2);
        for (int j=0;j < nrows;j++) {
           String s = (String) tableModel.getValueAt(j,d);
           if (s.length()>0) {
           comp = table.getDefaultRenderer(tableModel.getColumnClass(2)).
                         getTableCellRendererComponent(
                             table, s ,false, false, j, 2);
           cellWidth = Math.max(cellWidth, comp.getPreferredSize().width);
           }
        }
        if (column.getHeaderRenderer()!=null) {
            comp = column.getHeaderRenderer().
                      getTableCellRendererComponent(
                      table, column.getHeaderValue(), false, false, 0, 0);
             cellWidth = Math.max(cellWidth, comp.getPreferredSize().width);
             }
        column.setPreferredWidth(cellWidth+15);   
    } 
            
  class DataTableColumnModel extends DefaultTableColumnModel {
      class MyTableColumn extends TableColumn {
         MyTableColumn(int i, String name) {
            super(i, 80, i<=1?(TableCellRenderer) new Renderer0():
            (TableCellRenderer) new Renderer1(), null);
            setHeaderValue(name);    
            }      
         }
      
       DataTableColumnModel() {
         addColumn(new MyTableColumn(0,"name"));
         addColumn(new MyTableColumn(1,"sort"));
         addColumn(new MyTableColumn(2,"state"));
         }
      }
      
      private Class getObjectClass() {
          try {
             return Class.forName("java.lang.Object");
             }
          catch(Exception e) {
           e.printStackTrace();
           System.exit(1);
           }
          return null;
          }
          
      public void update(Vector v, boolean b) { 
        if (data!=null) {
           int n = data.size();
           w = new Vector(n);
           Iterator it = data.iterator();it.next(); //Skip empty line
           while (it.hasNext()) w.add(((String[]) (it.next()))[2]); 
           }
	data = accept(v);
        initColumnSize2();
        if (b) {
	    int n0=w.size();
	    if (v.size()/3>n0) m++;
	    dm.fireTableStructureChanged(); 
	    } 
	else  dm.fireTableDataChanged();
        table.changeSelection(0,0,true, false);
        table.editCellAt(0,0);
        // table.setRowSelectionInterval(0,0);
        // table.setColumnSelectionInterval(0,0);
        }
      
      private Vector accept(Vector v) {
        Vector data = new Vector(v.size()/3+1);
        if (v.size()==0 || !((String)(v.get(0))).equals("")) {
           data.add(new String[]{"","",""});
           }
        for (int i=0;i<v.size();i+=3) {
          String[] w = new String[] {
              (String) (v.get(i)), (String) v.get(i+1), (String) v.get(i+2)};
          // System.err.println("v:"+(String) (v.get(i))+":");
          data.add(w);
          }
        return data;
        }
            
      public StateTable(Vector v) {
        dm = new AbstractTableModel() {
          public int getRowCount() {return data.size();}
          public int getColumnCount() {return 3;}
          public Object getValueAt(int r, int c) {
            return ((String[])(data.get(r)))[c]; 
            }
          public boolean isCellEditable(int rowIndex, int columnIndex) {
            return rowIndex<m && columnIndex==0;
            }
        };
        DataTableColumnModel dcm =  new DataTableColumnModel();
        data = accept(v);
        table = new JTable(dm, dcm);
        table.setSurrendersFocusOnKeystroke(true);
	edt = (JTextField) (((DefaultCellEditor)
	table.getDefaultEditor(Object.class)).
	getComponent());
	edt.setAction(new AbstractAction() {
	  public void actionPerformed(ActionEvent e) {
	     String s = ((JTextComponent) (e.getSource())).getText();
	     Main.request.sendMsg(new UpdateStateMsg(table.getEditingRow(), s));
             ((String[]) (data.get(table.getEditingRow())))[0] = s;
             ((String[]) (data.get(table.getEditingRow())))[1] = ""; 
             ((String[]) (data.get(table.getEditingRow())))[2] = "";
	     }
	  });
        // table.editCellAt(0,0);
        initColumnSize2();
        renderer0 = (DefaultTableCellRenderer) 
              (table.getTableHeader().getDefaultRenderer());
        renderer1 = (DefaultTableCellRenderer) 
              (table.getDefaultRenderer(getObjectClass()));
        headerBackground = table.getTableHeader().getBackground();
        table.setAutoResizeMode(JTable.AUTO_RESIZE_OFF);
        table.setCellSelectionEnabled(false);
        table.setColumnSelectionAllowed(false);
        table.setRowSelectionAllowed(false);
        // table.setFocusable(false);
        // table.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
        // table.setEditingColumn(0);
        setViewportView(table);
        getViewport().setPreferredSize(table.getPreferredSize());
        setBorder(BorderFactory.createTitledBorder(
         BorderFactory.createEtchedBorder(), 
           "Current State",
          TitledBorder.CENTER, TitledBorder.ABOVE_TOP)); 
        }
    }
