/*$Id: SteprankMsg.java,v 1.1 2004/01/09 14:59:59 bertl Exp $*/
package jsim;

import java.awt.*;
import java.awt.event.*;
import java.util.Vector;
import javax.swing.*;
import javax.swing.table.*;
class MarkMsg extends Msg {
     
  final Nsim frame;
  
  public MarkMsg(Nsim frame) {
     setId("mark");
     this.frame = frame;
     }
     
  public MarkMsg(String idx) {
     setId("mark");
     this.addArg(idx);
     this.frame = null;
     } 
              
  public boolean Do() {
     Runnable updateLabel = new Runnable() {
          public void run() {
              if (frame!=null) {
              frame.nodes.content.setData(argList);
              frame.nodes.content.initColumnSizes();
              ((AbstractTableModel) (frame.nodes.content.table.getModel())).
                  fireTableStructureChanged();
              }
              }
          };
     try {
        SwingUtilities.invokeAndWait(updateLabel);
        }
     catch (Exception e) {
        e.printStackTrace();
        }
     return true;
     }
  }
  
class SmdMsg extends Msg {
     
  final Nsim frame;
  
  public SmdMsg(Nsim frame) {
     setId("smd");
     this.frame = frame;
     }
           
  public boolean Do() {
     Runnable updateLabel = new Runnable() {
          public void run() {
              if (frame!=null) {
              synchronized(argList) {
              frame.choice.smds.setListData(argList);
              }
              }
              }
          };
     try {
        SwingUtilities.invokeAndWait(updateLabel);
        }
     catch (Exception e) {
        // e.printStackTrace();
        }
     return true;
     }
  }

class DepthcontentMsg extends Msg {
  final Nsim frame;
  
  public DepthcontentMsg(Nsim frame) {
     setId("depthcontent");
     this.frame = frame;
     }
     
  public DepthcontentMsg() {
     setId("depthcontent");
     this.frame = null;
     } 
       
  public boolean Do() {
     Runnable updateLabel = new Runnable() {
          public void run() {
              if (frame!=null) {
              frame.choice.depthAction.setText((String)(argList.remove(0)));
              frame.choice.depthSmd.setText((String)(argList.remove(0)));
              frame.choice.depthAction.setActionCommand((String)(argList.remove(0)));
              frame.choice.depthAction.setEnabled(Boolean.valueOf
                     ((String)(argList.remove(0))).booleanValue()); // Redo
              }
              }
          };
     try {
        SwingUtilities.invokeAndWait(updateLabel);
        }
     catch (Exception e) {
        e.printStackTrace();
        }
     return true;
     }
  }
      
  
class SteprankMsg extends Msg {
  final Nsim frame;
  
  public SteprankMsg(Nsim frame) {
     setId("steprank");
     this.frame = frame;
     }
     
  public SteprankMsg(String idx) {
     setId("steprank");
     this.addArg(idx);
     this.frame = null;
     } 
       
  public boolean Do() {
     return true;
     }
  }
