/* $Id: ClusterTable.java,v 1.5 2003/04/17 14:12:43 bertl Exp $ */
package stateview;
import java.io.*;
import java.util.List;
import java.util.*;
import aterm.*;
import aterm.pure.*;
import javax.swing.*;
import javax.swing.event.*;
import javax.swing.table.*;
import java.awt.*;
import java.awt.event.*;
import att.grappa.*;


/** The table containing information about the whole cluster. */
class ClusterTable extends JTable {
         
/** computes the width of the columns in the table */  
  protected void initColumnSizes() {
        Component comp = null;
        TableModel tableModel = getModel();
        int ncols = getColumnCount();
        int nrows = getRowCount();
        Enumeration enum = getColumnModel().getColumns();
        for (int i=0;enum.hasMoreElements();i++) {
            TableColumn column = (TableColumn) enum.nextElement();
            int d = column.getModelIndex();
            int cellWidth = 0;
            // column.sizeWidthToFit();
            // cellWidth = column.getPreferredWidth();
            for (int j=0;j < nrows;j++) {
                comp = getDefaultRenderer(tableModel.getColumnClass(d)).
                             getTableCellRendererComponent(
                                 this, tableModel.getValueAt(j,d),
                                 false, false, j, i);
                 cellWidth = Math.max(cellWidth, comp.getPreferredSize().width);
            }
            comp = column.getHeaderRenderer().
                             getTableCellRendererComponent(
                                 this, tableModel.getColumnName(d),
                                 false, false, 0, 0);
            cellWidth = Math.max(cellWidth, comp.getPreferredSize().width);
            column.setPreferredWidth(cellWidth+15);
            
        }
        
    } 

/** creates map from transition to row number 
* @param id number of the cluster 
*/ 
      
  static String string(int j) {
     return "0";
     }
                 
/** creates the table of the state variables */      
   public ClusterTable(TableModel dm, DefaultTableColumnModel dcm) {   
      super(dm, dcm);
      setAutoResizeMode(JTable.AUTO_RESIZE_OFF);
      setColumnSelectionAllowed(false);
      setRowSelectionAllowed(false);      
      setSelectionBackground(
           Color.yellow.brighter().brighter().brighter()
           );
      // this.setFont(Stateview.font); 
      initColumnSizes();
      }
      
}

class MainTable {
   AbstractTableModel dm;
   DefaultTableColumnModel dcm;
   JTable table;
   MainTable(final Cluster cluster, DefaultTableCellRenderer renderer) {
       if (cluster.smds.size()==0 || Data.clusterNames.size()==0) return;
       final StateTable stateTable = new StateTable(cluster);
       final VariableTable variableTable = new VariableTable(cluster, renderer);
       
       dm = new AbstractTableModel() {
                  public int getRowCount() {return cluster.smds.size();}
                  public int getColumnCount() {
                        return stateTable.dcm.getColumnCount()+
                        variableTable.dcm.getColumnCount();}
                  public Object getValueAt(int r, int c) {
                     if (c<Data.parameters.size())
                     return  variableTable.dm.getValueAt(r,c);
                     return stateTable.dm.getValueAt(r,c-Data.parameters.size());
                     }
                  public String getColumnName(int c) {
                     if (c<Data.parameters.size())
                        return  variableTable.dm.getColumnName(c);
                     return  stateTable.dm.getColumnName(c-Data.parameters.size());
                     }
                  };
       dcm =  new DefaultTableColumnModel();
             Enumeration enum = stateTable.dcm.getColumns();
             while (enum.hasMoreElements()) {
               TableColumn t = (TableColumn) enum.nextElement();
               t.setModelIndex(Data.parameters.size()+t.getModelIndex());
               dcm.addColumn(t);
               }
             enum = variableTable.dcm.getColumns();
             while (enum.hasMoreElements()) {
               TableColumn t = (TableColumn) enum.nextElement();
               // System.out.println(" "+t.getHeaderValue());
               
               dcm.addColumn(t);
               }
             table = new ClusterTable(dm, dcm);
             }     
       
   class StateTable {
      AbstractTableModel dm;
      DefaultTableColumnModel dcm;
      TableCellRenderer headerRenderer = new JTableHeader().getDefaultRenderer();
      StateTable(final Cluster cluster) {
          // if (cluster.smds.size()==0 || Data.clusterNames.size()==0) return null;
          dm = new AbstractTableModel() {
                  public int getRowCount() {return cluster.smds.size();}
                  public int getColumnCount() {return Data.clusterNames.size();}
                  public Object getValueAt(int r, int c) {
                     return  Data.summands[cluster.smdsA[r].intValue()].getTransition(c);
                     }
                  public String getColumnName(int c) {
                     return ((Parameter) (Data.clusterNames.get(c))).name;
                     }
                  };
          dcm =  new DefaultTableColumnModel();
             Iterator it = Data.clusterNames.iterator();
             for (int i=0;it.hasNext();i++) {
               Parameter parameter = (Parameter) it.next();
               TableColumn t = new TableColumn (i);
               t.setHeaderValue(parameter.name);
               t.setHeaderRenderer(headerRenderer);
               int j;
               for (j=0;j<dm.getRowCount() && 
               ((String) dm.getValueAt(j, i)).equals("") ;j++); 
               if (j<dm.getRowCount()) dcm.addColumn(t);
               }   
          }
      }
      
    class  VariableTable { 
      AbstractTableModel dm; 
      DefaultTableColumnModel dcm;
      TableCellRenderer headerRenderer = new JTableHeader().getDefaultRenderer();
      Object cache[][];          
      VariableTable(final Cluster cluster, DefaultTableCellRenderer renderer) {
      // if (cluster.smds.size()==0 || cluster.pars.size()==0) return null;
      if (cache==null) cache = 
           new Object [Data.nrows][Data.npars];
      dm = new AbstractTableModel() {
      public int getRowCount() {return cluster.smds.size();}
      public int getColumnCount() {return cluster.pars.size();}
      public Object getValueAt(int r, int c) {
         if (cache[r][c]==null) { 
              Summand smd =  Data.summands[cluster.smdsA[r].intValue()];  
              String s  = smd.nextStates[c];
              cache[r][c] = 
                 (Object)(((Parameter) Data.parameters.get(c)).name.equals(s)?"":
                      smd.FormattedTerm(s));
              }
         return cache[r][c];
         }
      public String getColumnName(int c) {
           return ((Parameter) Data.parameters.get(c)).name;}
      };
      dcm =  new DefaultTableColumnModel();
      Iterator it = cluster.pars.iterator();
       while (it.hasNext()) {
         Parameter parameter = (Parameter) it.next();
         TableColumn t =  new TableColumn(parameter.pos,10, renderer, null);
         // System.out.println(((Parameter) Data.parameters.get(parameter.pos)).
         //    name);
         t.setHeaderValue((String)
         ((Parameter) Data.parameters.get(parameter.pos)).name);
         t.setHeaderRenderer(headerRenderer); 
         dcm.addColumn(t);
         }   
      }
   }
} 
class IndexTable {       
 private AbstractTableModel dm;
 private DefaultTableColumnModel dcm;
 JTable table;
 TableCellRenderer headerRenderer = new JTableHeader().getDefaultRenderer();
 IndexTable(final Cluster cluster) {
    // if (cluster.smds.size()==0) return null;
      dm = new AbstractTableModel() {
      public int getRowCount() {return cluster.smds.size();}
      public int getColumnCount() {return 1;}
      public Object getValueAt(int r, int c) {
          return (Object) new Integer(cluster.smdsA[r].intValue()+1);}
      /* public String getColumnName(int c) {return "smd";} */
      };
    dcm =  new DefaultTableColumnModel();
    int max = 60;
    TableColumn t = new TableColumn(0, max); t.setMinWidth(max);
    t.setHeaderValue("smd");
    t.setHeaderRenderer(headerRenderer);
    dcm.addColumn(t);
    table = new ClusterTable(dm, dcm);
    table.setSelectionMode(
    ListSelectionModel.MULTIPLE_INTERVAL_SELECTION);  
    // table.setPreferredSize(table.getMaximumSize());
    table.setBackground(Color.lightGray);
    table.setAutoResizeMode(JTable.AUTO_RESIZE_OFF);
    table.setRowSelectionAllowed(true);
    table.setSelectionBackground(Color.red);
    }
}
