/* $Id: ShowClusterTables.java,v 1.4 2003/04/16 11:47:00 bertl Exp $ */
package stateview;
import java.awt.*;
import java.awt.event.*;
import java.io.*;
import java.util.*;
import javax.swing.*;
import javax.swing.table.*;
import javax.swing.border.*;
import att.grappa.*;
import aterm.*;
import aterm.pure.*;
/**
Displays tables. Rows are the summands in the cluster. Columns are occuring
parameters 
*/

      
public class ShowClusterTables extends JOptionPane {
   JTable indexTable, mainTable;
   class Renderer extends DefaultTableCellRenderer {
    public Component getTableCellRendererComponent(JTable table,
       Object value, boolean isSelected, boolean hasFocus, int row,
       int column) {
       Component c = super.getTableCellRendererComponent(table,
           value, mark[row][column], hasFocus, row, column);
       // System.out.println("r="+row+" c="+column+" mark:"+mark[row][column]);
       return c;
       }
    }
        
    private Rectangle bigBound = new Rectangle(new Dimension(600,600));
    final private Cluster cluster;
    /** transition -> row number */
    public Hashtable transitions = new Hashtable(20); 
    private boolean mark[][];
    private DefaultTableCellRenderer renderer = new Renderer();
    
    public void MarkCells() {
        Iterator it = cluster.pars.iterator();
        while (it.hasNext()) {
            Parameter par = (Parameter) it.next();
            // System.out.println("par:"+par.name);
            Iterator it2 = cluster.smds.iterator();
                int r = 0;
                while (it2.hasNext()) {
                   int d = ((Integer) it2.next()).intValue();
                   Summand smd = Data.summands[d];
                   if (smd.Occurs(par)>=0) {
                   /* System.out.println(""+mark.length+" "+
                   mark[0].length+ " "+
                   mainTable.convertColumnIndexToView(par.pos)+" "+
                   par.pos); */
                   //  System.out.println("changeSel:"+r+":"+par.pos);
                   // table.changeSelection(r, table.convertColumnIndexToView(
                   //   par.pos), false, true);
                   mark[r][mainTable.convertColumnIndexToView(par.pos)]=true;
                   }
                   r++;
               }
         }
      }

    
    private void createHashtable(int id) {
       Iterator it = cluster.smds.iterator();
       int i = 0;
       while (it.hasNext()) {
          Integer d = ((Integer) it.next());
          ArrayList transition = Data.summands[d.intValue()].transitions[id];
          Iterator it2 = transition.iterator();
          // if (id==3) System.out.println(transition);
          while (it2.hasNext())
              transitions.put(it2.next(), (Object) new Integer(i));
          i++;
          }   
      }
                
    public JDialog makeDialog(String name) {
      if (mainTable==null) return null;   
      JScrollPane sp = new  JScrollPane(mainTable);
      sp.setCorner(JScrollPane.UPPER_LEFT_CORNER,new JLabel("smd/par"));
      mainTable.setPreferredScrollableViewportSize(
              bigBound.intersection(
              new Rectangle(mainTable.getPreferredSize())).getSize());
      JViewport vpp = new JViewport();
      vpp.setView(indexTable);
      vpp.setPreferredSize(new Dimension(
          indexTable.getPreferredSize().width, mainTable.getPreferredSize().height));
      sp.setRowHeader(vpp);
      setMessage(sp); 
      JDialog diag = createDialog(null, name);
      diag.setModal(false);
      diag.setResizable(true);
      MouseListener[] mls = (MouseListener[])(
          mainTable.getListeners(MouseListener.class));
      for (int i=0;i<mls.length;i++) 
          mainTable.removeMouseListener(mls[i]);
      mls = (MouseListener[])(
          indexTable.getListeners(MouseListener.class));
      for (int i=0;i<mls.length;i++) 
          indexTable.removeMouseListener(mls[i]);
      return diag;
      }
      
    ShowClusterTables(Cluster cluster) {
      super(null,JOptionPane.PLAIN_MESSAGE,
      JOptionPane.DEFAULT_OPTION, (Icon) null, new String[]{"Dismiss"});
      this.cluster = cluster;
      this.mainTable =  (new MainTable(cluster, renderer)).table;
      if (this.mainTable==null) return;
      this.indexTable = (new IndexTable(cluster)).table;
      this.mark = new boolean[cluster.smds.size()][mainTable.getColumnCount()];
      createHashtable(cluster.id);
      }
  }
