/* $Id: ShowTable.java,v 1.3 2003/04/16 11:47:00 bertl Exp $ */
package stateview;
import java.awt.*;
import java.awt.event.*;
import java.io.*;
import java.util.*;
import javax.swing.*;
import javax.swing.table.*;
import att.grappa.*;
/**
The scrollable panel which contains a table. 
*/
class Table extends JScrollPane {
  private Object cache[]; 
  private TableModel dm;
  private DefaultTableColumnModel dcm;
  /**  The table which will be displayed. */
  public JTable table;
  /** The renderer of the 0th column. */
  private DefaultTableCellRenderer renderer0 = 
             new DefaultTableCellRenderer(); 
  /** The renderer of the 1th column. */              
  private DefaultTableCellRenderer renderer1 = 
             new DefaultTableCellRenderer();
  /**  @return the parameters whose entry in next state is different
       from its parameter name */
  private Parameters sieve(Parameters pars, int d) {
      Parameters r = new Parameters(pars.size());
      Summand smd = Data.summands[d];
      Iterator it = pars.iterator();
      while (it.hasNext()) {
           Parameter par = (Parameter) it.next();
           String s = smd.nextStates[par.pos];
           if (!s.equals(par.name)) r.add((Object) par);
           }
      return r;
      }
  /** The result of sieve.  */    
  Parameters parameters;
  /** The column model belonging to the table. */          
  class DataTableColumnModel extends DefaultTableColumnModel {
      class MyTableColumn extends TableColumn {
         MyTableColumn(int i, String name, TableCellRenderer renderer) {
            super(i);
            setCellRenderer(renderer);
            setHeaderRenderer(createDefaultHeaderRenderer());
            setHeaderValue(name);
            }       
         }
      /** Constructor.
      *    @param d number of summand
      */
       DataTableColumnModel(int d) {
         TableColumn 
         t = new MyTableColumn(0,"summand "+(d+1), renderer0); addColumn(t);
         t = new MyTableColumn(1,"value", renderer1); addColumn(t);
         }
      }
      
 /** Constructor.
 *    @param d number of summand
 */     
      public Table(final int d) {
        
        dm = new AbstractTableModel() {
          public int getRowCount() {return 2+parameters.size();}
          public int getColumnCount() {return 2;}
          public Object getValueAt(int r, int c) {
             if (c==0) {
                if (r==0) return (Object) "condition";
                if (r==1) return (Object) "action";
                 return (Object) (((Parameter) parameters.get(r-2)).name);
                 }
             if (c==1) {
                if (cache[r]==null) {
                    Summand smd = Data.summands[d];
                    if (r==0) cache[r] = (Object) 
                         (smd.FormattedTerm(smd.condition));
                    else
                    if (r==1) cache[r] =  (Object) 
                         (smd.FormattedTerm(smd.action));
                    else {
                      int pos = ((Parameter) parameters.get(r-2)).pos;
                      String s = smd.nextStates[pos],
                      name = ((Parameter) parameters.get(r-2)).name;
                      cache[r] = (Object) (s.equals(name)?"":
                             smd.FormattedTerm(s));
                      }
                   }
             return cache[r];
             } 
          return (Object) null;  
          }
        }; 
        JViewport vp;
        DataTableColumnModel dcm =  new DataTableColumnModel(d);
        parameters = sieve(Data.parameters.Minus(Data.clusterNames), d);
        if (cache==null) cache =  new Object[parameters.size()+2];
        table = new JTable(dm, dcm);
        table.setAutoResizeMode(JTable.AUTO_RESIZE_OFF);
        table.setCellSelectionEnabled(false);
        table.setColumnSelectionAllowed(false);
        table.setRowSelectionAllowed(false);
        renderer0.setForeground(Color.blue.darker());
        initColumnSizes();
        vp = new JViewport();vp.setView(table);
        vp.setPreferredSize(table.getPreferredSize()); 
        setViewport(vp);
        Rectangle bound = new Rectangle(new Dimension(700,700)); 
        Rectangle port = new Rectangle(
                       new Dimension(vp.getPreferredSize()));
        bound = port.intersection(bound); 
        if (!bound.equals(port)) { 
            getViewport().setPreferredSize(bound.getSize());
            } 
        }
 /** computes the width of the columns in the table */    
  private void initColumnSizes() {
        TableColumn column = null;
        Component comp = null;
        TableModel tableModel = table.getModel();
        int ncols = table.getColumnCount();
        int nrows = table.getRowCount();
        for (int i = 0; i < ncols ; i++) {
            int cellWidth = 0;
            int d = table.convertColumnIndexToModel(i);
            column = table.getColumnModel().getColumn(i);
            for (int j=0;j < nrows;j++) {
               String s = (String) tableModel.getValueAt(j,d);
               if (s.length()>0) {
               comp = table.getDefaultRenderer(tableModel.getColumnClass(i)).
                             getTableCellRendererComponent(
                                 table, s ,false, false, j, i);
               cellWidth = Math.max(cellWidth, comp.getPreferredSize().width);
               }
            }
        if (column.getHeaderRenderer()!=null) {
            comp = column.getHeaderRenderer().
                      getTableCellRendererComponent(
                      table, column.getHeaderValue(), false, false, 0, 0);
             cellWidth = Math.max(cellWidth, comp.getPreferredSize().width);
             }
           column.setPreferredWidth(cellWidth+15);
           }   
        }
    }

/** The dialog window which contains the table. */              
public class ShowTable extends JOptionPane {
    
    private void makeDialog(final int d, String name) {
      setMessage(new Table(d));
      JDialog diag = createDialog(null, name);
      diag.setModal(false);
      diag.setVisible(true);
      diag.setResizable(true);
      }
/** Class constructor. 
* @param d number of summand
* @param name name of the cluster
*/   
    ShowTable(final int d, String name) {
      super(null,JOptionPane.PLAIN_MESSAGE,
      JOptionPane.DEFAULT_OPTION, (Icon) null, new String[]{"Dismiss"});
      makeDialog(d, "cluster: "+name+" summand: "+(d+1));
      }
  }
